;;;  

(defun bltsob (/	    	     apsz	 osmd	dmt    dln    dln1
	     dgb    sgb	   hgb	  dvt	 fsk	rsp    cpt    pt1
	     pt2	 pt3	pt4    pt5    pt6
	     pt7    pt8	   pt9	  pt10	 pt11	pt12   
	     tgb
	     tgbt   tgbn   edat3  obj1   clay  cltp ccol
	    )


  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))


  (setq	dmt  (nth 3 bb)
	dln  (nth 4 bb)
	dln1 (nth 5 bb)
	dgb  (nth 6 bb)
	sgb  (nth 7 bb)
	hgb  (nth 8 bb)
	dvt  (nth 9 bb)
	fsk  (nth 10 bb)
	rsp  (nth 11 bb)
        imja (strcat " M" (rtos dmt) "x" (rtos (nth 13 bb) 2 2) "x" (rtos dln) "  " imja2)
  ) ;_ end of setq



  (defun ris_blt ()

    (setq cpt '(0.0 0.0 0.0))
    (setvar "osmode" 0)
    (setvar "aperture" 1)


;;;;;;; 
    (defun bl_vs ()
      (setq tgb	 (/ (sqrt (- (expt dgb 2) (expt sgb 2))) sgb)
	    tgbt (atan tgb)
      ) ;_ end of setq
      (setq pt1	 (polar cpt tgbt (/ dgb 2.0))
	    pt3	 (polar cpt (+ tgbt (/ pi 3)) (/ dgb 2.0))
	    pt5	 (polar cpt (+ tgbt (* (/ pi 3) 2)) (/ dgb 2.0))
	    pt7	 (polar cpt (+ tgbt pi) (/ dgb 2.0))
	    pt9	 (polar cpt (+ tgbt (* (/ pi 3) 4)) (/ dgb 2.0))
	    pt11 (polar cpt (+ tgbt (* (/ pi 3) 5)) (/ dgb 2.0))
	    tgbn (- pi tgbt)
	    pt6	 (polar cpt tgbn (/ dgb 2.0))
	    pt8	 (polar cpt (+ tgbn (/ pi 3)) (/ dgb 2.0))
	    pt10 (polar cpt (+ tgbn (* (/ pi 3) 2)) (/ dgb 2.0))
	    pt12 (polar cpt (+ tgbn pi) (/ dgb 2.0))
	    pt2	 (polar cpt (+ tgbn (* (/ pi 3) 4)) (/ dgb 2.0))
	    pt4	 (polar cpt (+ tgbn (* (/ pi 3) 5)) (/ dgb 2.0))
      ) ;_ end of setq


      (command "_pline" pt1 "_a" "_ce" cpt pt2 "_l" pt3 "_a" "_ce" cpt pt4
 	               "_l" pt5 "_a" "_ce" cpt pt6 "_l" pt7 "_a" "_ce" cpt pt8 
	       "_l" pt9 "_a" "_ce" cpt pt10 "_l" pt11 "_a" "_ce" cpt pt12
                    "_l" pt1 "" "_extrude" (entlast) "" (- 0 hgb) "")
      (setq obj1 (entlast))
      (setq SS (ssadd))
      (command "_line" (list (car cpt) (+ (cadr cpt) (* 0.45 sgb)) (- (caddr cpt) hgb)) 
                       (list (car cpt) (+ (cadr cpt) (* 0.5 dgb)) (- (caddr cpt) hgb)) "")
      (ssadd (entlast) SS)
      (command "_line" (list (car cpt) (+ (cadr cpt) (* 0.5 dgb)) (- (caddr cpt) hgb)) 
                       (list (car cpt) (+ (cadr cpt) (* 0.5 dgb)) 
                              (+ (- (caddr cpt) hgb) (* (- (* 0.5 dgb) (* 0.45 sgb)) 
                                                (/ (sin (/ pi 6)) (cos (/ pi 6))) 
                                               ) 
                               )
                          ) "")
      (ssadd (entlast) SS)
      (command "_line" (list (car cpt) (+ (cadr cpt) (* 0.5 dgb)) 
                              (+ (- (caddr cpt) hgb) (* (- (* 0.5 dgb) (* 0.45 sgb)) 
                                                (/ (sin (/ pi 6)) (cos (/ pi 6))) 
                                               ) 
                               )
                          ) 
                       (list (car cpt) (+ (cadr cpt) (* 0.45 sgb)) (- (caddr cpt) hgb)) "") 
      (ssadd (entlast) SS)
      (command "_region" ss "" 
               "_revolve" (entlast) "" cpt (list (car cpt) 
                                                 (cadr cpt) 
                                                 (+ (caddr cpt) 5.0)
                                            ) 360 
               "_subtract" obj1 "" (entlast) ""
        )
      (command "_ucs" "_n" "_x" 90.0)
      (if (eq dln dln1)
       (command "_pline" (list (+ (car cpt) (* dmt 0.5) rsp) 
                                  (cadr cpt) 
                                  (caddr cpt) 
                             )
                         (list (car cpt) 
                               (cadr cpt) 
                               (caddr cpt) 
                             )
                         (list (car cpt)
                               (+ (cadr cpt) dln) 
                               (caddr cpt) 
                         )
                         (list (- (+ (car cpt) (* dmt 0.5)) fsk)
                               (+ (cadr cpt) dln) 
                               (caddr cpt) 
                         ) 
                         (list (+ (car cpt) (* dmt 0.5)) 
                             (+ (cadr cpt) (- dln fsk)) 
                             (caddr cpt) 
                         ) 
                         (list (+ (car cpt) (* dmt 0.5)) 
                             (+ (cadr cpt) rsp) 
                             (caddr cpt) 
                        )
                "_a"  "_ce" (list (+ (car cpt) (* dmt 0.5) rsp) 
                                  (+ (cadr cpt) rsp) 
                                  (caddr cpt) 
                             ) 
                            (list (+ (car cpt) (* dmt 0.5) rsp) 
                                  (cadr cpt) 
                                  (caddr cpt) 
                             ) "" 
               "_revolve" (entlast) "" cpt (list (car cpt) 
                                                 (+ (cadr cpt) 5.0)
                                                 (caddr cpt)
                                            ) 360 
         )   
       (command "_pline" (list (+ (car cpt) (* dmt 0.5) rsp) 
                                  (cadr cpt)
                                  (caddr cpt) 
                             );1-
                         (list (car cpt) 
                               (cadr cpt) 
                               (caddr cpt) 
                             );6-
                         (list (car cpt)
                               (+ (cadr cpt) dln) 
                               (caddr cpt) 
                         );5-
                         (list (- (+ (car cpt) (* dmt 0.5)) fsk)
                               (+ (cadr cpt) dln) 
                               (caddr cpt) 
                         ) ;4-
                         (list (+ (car cpt) (* dmt 0.5)) 
                             (+ (cadr cpt) (- dln fsk)) 
                             (caddr cpt) 
                         ) ;3-
                         (list (+ (car cpt) (* dmt 0.5)) 
                               (- (+ (cadr cpt) 
                                     dln 
                                    (* (/ (* (- dmt dvt) 0.5 (sin (/ pi 6))) (cos (/ pi 6))) 2.0)
                                   ) 
                                  dln1 
                                 )
                             (caddr cpt) 
                         ) ;31-
                         (list (+ (car cpt) (* dvt 0.5)) 
                               (- (+ (cadr cpt) 
                                     dln 
                                     (/ (* (- dmt dvt) 0.5 (sin (/ pi 6))) (cos (/ pi 6)))
                                   ) 
                                  dln1 
                                 )
                             (caddr cpt) 
                         ) ;32-
                         (list (+ (car cpt) (* dmt 0.5)) 
                               (- (+ (cadr cpt) dln) dln1)
                               (caddr cpt) 
                         ) ;33-
                         (list (+ (car cpt) (* dmt 0.5)) 
                             (+ (cadr cpt) rsp) 
                             (caddr cpt) 
                        );2-
                "_a"  "_ce" (list (+ (car cpt) (* dmt 0.5) rsp) 
                                  (+ (cadr cpt) rsp) 
                                  (caddr cpt) 
                             ) 
                            (list (+ (car cpt) (* dmt 0.5) rsp) 
                                  (cadr cpt) 
                                  (caddr cpt) 
                             ) "" 
               "_revolve" (entlast) "" cpt (list (car cpt) 
                                                 (+ (cadr cpt) 5.0)
                                                 (caddr cpt)
                                            ) 360 
         ) 
      );_end of if   
        (command "_ucs" "_p" "_union" obj1 (entlast) "")     
	(setvar "aperture" apsz)
	(setvar "osmode" osmd)
       (command "-hyperlink" "_insert" "_object" (entlast) "" "" "" imja)
       (command "_move" (entlast) "" cpt pause)
    ) ;_ end of defun
;;; _end of  BL_VS

    (bl_vs)

  ) ;_ end of defun
;;;_end of RIS_BLT




	(ris_blt)




  (setvar "cmdecho" cmd)   
  (setvar "blipmode" blpm) 
  (prin1)
) ;_ end of defun BLTSOB
